# frozen_string_literal: true

require_relative 'conjunction'

module Zenlish
  module WClasses
    # A subordinating conjunction is a word or phrase that connects a dependent
    # clause to a main clause. The subordinating conjunction indicates how the
    # dependent clause adds informative value to the main clause. For instance,
    # by signaling a cause-and-effect relation, a shift in time or place between
    # the two clauses.
    # Common subordinating conjunctions: after, although, as, because, before,
    # how, if, once, since, than, that, though, till, until, when, where,
    # whether, while
    class SubordinatingConjunction < WordClass
    end # class
  end # module
end # module
